---
# {{ ansible_managed }}
version: '3.3'

services:
  db:
    image: "{{ bc_portal_postgres_image }}"
    restart: always
    environment:
      POSTGRES_PASSWORD: "{{ bc_portal_postgresql_password }}"
      POSTGRES_USER:  "{{ bc_portal_postgresql_user }}"
      POSTGRES_DB:  "{{ bc_portal_postgresql_database }}"
    {% if bc_portal_debug %}
    ports:
      - "127.0.0.1:5432:5432"
    {% endif -%}
    volumes:
      - db-data:/var/lib/postgresql

  matrix-webhook:
    image: nim65s/matrix-webhook
    restart: always
    environment:
      MATRIX_ID: "{{ bc_portal_matrix_id }}"
      MATRIX_PW: "{{ bc_portal_matrix_password }}"
      API_KEY: "{{ bc_portal_matrix_api_key }}"
  {% if bc_portal_debug %}
    ports:
      - "127.0.0.1:4785:4785"
  {% endif %}

  db-upgrade:
    image: "{{ bc_portal_portal_image }}"
    entrypoint: "flask db upgrade"
    restart: "no"
    volumes:
      - /var/lib/portal-docker-compose/bc_configuration.yaml:/srv/bc/config.yaml
    depends_on:
      - db

  portal:
    image: "{{ bc_portal_portal_image }}"
    ports:
      - "0.0.0.0:8080:8080"
    volumes:
      - terraform-config:/terraform
      - /var/lib/portal-docker-compose/bc_configuration.yaml:/srv/bc/config.yaml
      - ssh:/ssh
    environment:
      FLASK_APP: "app"
      FLASK_RUN_HOST: "0.0.0.0"
      FLASK_RUN_PORT: "8080"
    entrypoint: "bash -c 'sleep 15; flask run'"
    depends_on:
      - db

  cron:
    image: "{{ bc_portal_portal_image }}"
    volumes:
      - terraform-config:/terraform
      - /var/lib/portal-docker-compose/bc_configuration.yaml:/srv/bc/config.yaml
      - ssh:/ssh
    depends_on:
      - portal
    entrypoint: "cron -f"

volumes:
  terraform-config:
  ssh:
  db-data:
